
************************************************************************
* POSTBAR.PRG
* FUNCTION: FoxPro Postal Bar Code printer
*            (c) Copyright 09/10/1994 by Beverly Howard
*            205 Canyon Rim Drive, Austin, TX 78746-5016
* 
*               phone (512) 327-3230 for information
* 
*  All rights reserved, no part of this program may be reproduced
*            without written permission from the author.
************************************************************************
param pcv1,plv1,pcv4

set echo off
set debug off
set talk off
if !printstatus()
	wait window nowait "Postnet barcodes disabled (printer not ready)"
	return
endif
do case
case type("pcv1") <> "C"
   return
case len(trim("pcv1")) = 0
   return
case type("pcv1") $ "?H"
   do bcdoc
   return
case type("pcv4") = "L"
   pcv4="EPSON"
endcase
IF SYS(103)="ON"
   SET TALK OFF
ENDIF

*pcv1=zipcode (char)
*pcv2=barstack
*pcv3=barref
*pnv1=val(digit)
*pnv2=digitsum
*each digits printed code (including check digit)
* is 2.5 chars of normal 10cpi print

pcv1=trim(pcv1)+"|"
pcv2="1"
pnv2=0
pcv3="11000000110010100110010010101001100100011001010100"
pcv5=""
do while pcv1 <> "|"
   if isdigit(pcv1)
      pnv1=val(left(pcv1,1))
      pnv2=pnv2+pnv1
      pcv2=pcv2+subst(pcv3,(pnv1*5)+1,5)
      pcv5=pcv5+left(pcv1,1)
   endif
   pcv1=subst(pcv1,2)
enddo
pnv1=10-mod(pnv2,10)
pcv2=pcv2+subst(pcv3,(pnv1*5)+1,5)
pcv5=pcv5+right(str(pnv1),1)
pcv2=pcv2+"1"
clear
*activate window debug
*set step on

do case
case type("_BOX")<>"U"
   store "???" to pcv3
case sys(101)="PRINT"
   store "@ ROW(),COL() SAY" to pcv3
case sys(102)="ON"
   store "??" to pcv3
otherwise
   clear
   ? "Unable to determine PRINT status setting.  Returning to program..."
   wait
   return
endcase

do case
case _WINDOWS 
	pcv5 = "s"+PCV5+"s"
	if upper(pcv4)="SAY"
		@ $,$ SAY pcv5 FONT 'ZipCodeBarcodeTT', 12
	else
		return pcv5
	endif
case pcv4="EP"
   if plv1
      store "L" to pcv1
      store 2 to pnv3
   else
      store "K" to pcv1
      store 1 to pnv3
   endif
   pnv1=mod(len(pcv2)*3*pnv3,256)
   pnv2=int(len(pcv2)*3*pnv3/256)
   &pcv3 chr(27)+pcv1+chr(pnv1)+chr(pnv2)         && begin graphics
   pnv1=0
   do while pnv1<len(pcv2)
      *space=chr(0) 0=chr(7) 1=chr(256)
      pnv1=pnv1+1
      pnv2=(val(subst(pcv2,pnv1,1)))
      
      *chr(7+(pnv2*248))=short bar if pnv2=0, long bar if pnv2=1 
      
      &pcv3 replicate(chr(7+(pnv2*248)),pnv3)+replicate(chr(0),2*pnv3)
   enddo
   * position error after print
   * test line   &pcv3 "1234567890a"+chr(13)+chr(10)
   
case pcv4 = "HP"
   wait "HP compatable routine not included in this packet..."      
case pcv4 = "OKI"
   store 1 to pnv3
   &pcv3 chr(3)         && begin graphics
   pnv1=0
   do while pnv1<len(pcv2)
      pnv1=pnv1+1
      pnv2=(val(subst(pcv2,pnv1,1)))
      
      * 15+(pnv2*112)=short bar if pnv2=0, long bar if pnv2=1 
      * 15+112=127 (full bar) chr(121)=short bar
      
*      &pcv3 replicate(chr(15+(pnv2*112)),pnv3)+replicate(chr(0),2*pnv3)
      &pcv3 replicate(chr(112+(pnv2*15)),pnv3)+replicate(chr(0),2*pnv3)
   enddo
   &pcv3 chr(3)+chr(2)  && end graphics
   
otherwise
endcase
return

proc bcdoc
   clear
   text
   UDF Format is "POSTBAR(<zipcodeC> [,hi-densityL] [,printertypeC])"
   
   Zipcode should consist of DIGITS ONLY, without spaces or dashes.
   
   Zipcode should conform to USPS requirements and consist of either
      5, 9 or 11 digits. This UDF does not make any corrections to the
      digits presented and will create a barcode for any combination
      of digits presented that MAY OR MAY NOT meet postal requiements.
      
      It is the programmer's responsibility to assure that the data
      presented has been selected and processed correctly.
   
   This UDF DOES calculate and add the correction digit per USPS specs.
   
   Printers supported with this version are "EPSON" & "OKIDATA"
   
   To print a high density barcode (slower, but more likely to scan
      correctly) the second UDF parameter should be .T.

   To specify a printer (when available) the second UDF parameter should
      be .F. to specify normal density

   Contact the author for information on "HPII/III" version of this UDF
   
   The DEFAULT printer type is "EPSON"
   
   endtext
   WAIT
   clear
   text
   This code uses the following variable names;
      PCV1, PCV2, PCV3, PCV4, PNV1, PNV2, PNV3 & PLV1
      
   If any of these conflict with your existing code, remember to store
      and restore their values before and after every use of this UDF.

   endtext
   WAIT
   clear
   text
   This program may be used for marking private and nonprofit mail
      at no cost to the user.
   
   Commercial and Government users must purchase a license for
      each computer using this code.
      
      Contact Beverly Howard, Byte Aid!
      205 Canyon Rim Drive
      Austin, TX 78746-5016
      (512) 327-3230
   
if type("TIPRTINIT") = "U"
   ??? 
   public TIPRTINIT
   TIPRTINIT = "EPSON"
endif

  
   endtext
